- name: Resolves current version
  set_fact:
    current_as_version: "{{ (as_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[1]
                                if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                    and as_dc.resources[0].spec.template is defined
                                    and as_dc.resources[0].spec.template.spec is defined
                                    and as_dc.resources[0].spec.template.spec.containers is defined
                                    and as_dc.resources[0].spec.template.spec.containers[0] is defined
                                    and as_dc.resources[0].spec.template.spec.containers[0].image is defined
                                    and (as_dc.resources[0].spec.template.spec.containers[0].image.split(':')) | length == 2)
                                else ((as_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[2]
                                    if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                        and as_dc.resources[0].spec.template is defined
                                        and as_dc.resources[0].spec.template.spec is defined
                                        and as_dc.resources[0].spec.template.spec.containers is defined
                                        and as_dc.resources[0].spec.template.spec.containers[0] is defined
                                        and as_dc.resources[0].spec.template.spec.containers[0].image is defined)
                                    else (as_dc.resources[0].spec.triggers[0].imageChangeParams.from.name.split(':'))[1]) }}"
- block:
  - name: Fails if current version unknown
    fail:
      msg: "Airsonic tag unknown {{ current_as_version }}"
    when:
    - current_as_version not in [ '10.6.2', '11.0.0-SNAPSHOT.20210902001057', '11.0.0-SNAPSHOT.20210908073208', '11.0.0-SNAPSHOT.20210908073208-1', '11.0.0-SNAPSHOT.20211001065822', '11.0.0-SNAPSHOT.20211019030336', '11.0.0-SNAPSHOT.20211220002741', '11.0.0-SNAPSHOT.20220320083637', '11.0.0-SNAPSHOT.20220418221611', '11.0.0-SNAPSHOT.20220625052932' ]
  - name: Checks upgrade supported
    fail:
      msg: "Can not upgrade from {{ current_as_version }} to {{ airsonic_tag }}"
    when:
    - >
        (current_as_version == '11.0.0-SNAPSHOT.20220625052932' and airsonic_tag in [ '11.0.0-SNAPSHOT.20211019030336',
             '11.0.0-SNAPSHOT.20210908073208-1', '11.0.0-SNAPSHOT.20211001065822', '11.0.0-SNAPSHOT.20210908073208',
             '11.0.0-SNAPSHOT.20210902001057', '10.6.2', '11.0.0-SNAPSHOT.20211220002741', '11.0.0-SNAPSHOT.20220320083637',
             '11.0.0-SNAPSHOT.20220418221611' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20220418221611' and airsonic_tag in [ '11.0.0-SNAPSHOT.20211019030336',
             '11.0.0-SNAPSHOT.20210908073208-1', '11.0.0-SNAPSHOT.20211001065822', '11.0.0-SNAPSHOT.20210908073208',
             '11.0.0-SNAPSHOT.20210902001057', '10.6.2', '11.0.0-SNAPSHOT.20211220002741', '11.0.0-SNAPSHOT.20220320083637' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20220320083637' and airsonic_tag in [ '11.0.0-SNAPSHOT.20211019030336',
             '11.0.0-SNAPSHOT.20210908073208-1', '11.0.0-SNAPSHOT.20211001065822', '11.0.0-SNAPSHOT.20210908073208',
             '11.0.0-SNAPSHOT.20210902001057', '10.6.2', '11.0.0-SNAPSHOT.20211220002741' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20211220002741' and airsonic_tag in [ '11.0.0-SNAPSHOT.20211019030336',
             '11.0.0-SNAPSHOT.20210908073208-1', '11.0.0-SNAPSHOT.20211001065822', '11.0.0-SNAPSHOT.20210908073208',
             '11.0.0-SNAPSHOT.20210902001057', '10.6.2' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20211019030336' and airsonic_tag in [ '11.0.0-SNAPSHOT.20210908073208-1',
             '11.0.0-SNAPSHOT.20211001065822', '11.0.0-SNAPSHOT.20210908073208', '11.0.0-SNAPSHOT.20210902001057', '10.6.2' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20211001065822' and airsonic_tag in [ '11.0.0-SNAPSHOT.20210908073208-1',
             '11.0.0-SNAPSHOT.20210908073208', '11.0.0-SNAPSHOT.20210902001057', '10.6.2' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20210908073208-1' and airsonic_tag in [ '11.0.0-SNAPSHOT.20210908073208',
             '11.0.0-SNAPSHOT.20210902001057', '10.6.2' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20210908073208' and airsonic_tag in [ '11.0.0-SNAPSHOT.20210902001057', '10.6.2' ])
        or (current_as_version == '11.0.0-SNAPSHOT.20210902001057' and airsonic_tag in [ '10.6.2' ])
  - include_role:
      name: airsonic
      tasks_from: upgrade-step.yaml
    vars:
      target: "{{ airsonic_tag }}"
    when:
    - airsonic_tag != current_as_version
  when:
  - current_as_version != 'master'
  - current_as_version != 'devel'
  - current_as_version != 'stage'
- name: Issue a warning when migrating from master to release
  debug:
    msg: |
      WARNING - about to deploy {{ airsonic_tag }} over CI version {{ current_as_version }}
  when:
  - current_as_version in [ 'master', 'devel', 'stage' ]
